



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>QPainter绘制遇到的小问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">QPainter绘制遇到的小问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 05:47:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<pre class="prettyprint linenums"></pre>
<p>1.Qt绘图基础</p>
<p>（1）绘图需画笔和画布：</p>
<ul><li>QPainter 相当于Qt中的一个画笔，绘制时需要一块画布，</li>
<li>Qt中扮演画布角色的组件为QPaintDevice和他的各个子类，如：&nbsp;QWidget, QPixmap, QPixture...</li>
<li>QPainter、QPaintDevice之间使用 QPaintEngine 进行通讯（也就是翻译 QPainter 的指令的意思）</li></ul>
<p>（2）怎么画</p>
<ul><li>通常都是要在哪个 widget 上绘图，就需要在它的&nbsp;<code>paintEvent()</code>&nbsp;函数里绘图，即重写 paintEvent() 函数</li></ul>
<p>（3）实例</p>
<p>PaintTest.h</p>
<div>
<pre class="prettyprint linenums"> #ifndef PAINTTEST_H<br />
 #define PAINTTEST_H

 #include &lt;QWidget&gt;<br />
 #include &lt;QLabel&gt;<br />
 #include &lt;QPainter&gt;<br />
 class PaintTest : public QWidget<br />
 {<br />
     Q_OBJECT<br />
 private:<br />
     QLabel *la;<br />
 public:<br />
     explicit PaintTest(QWidget *parent = );<br />
     void paintEvent(QPaintEvent *);

 };<br />
 #endif // PAINTTEST_H</pre>
</div>
<p>PaintTest.cpp</p>
<div>
<pre class="prettyprint linenums"> #include "PaintTest.h"<br />
 #include &lt;QLabel&gt;<br />
 #include &lt;QEvent &gt;<br />
 PaintTest::PaintTest(QWidget *parent) :<br />
     QWidget(parent),la(new QLabel(this))<br />
 {<br />
     la-&gt;setText("PaintTest Label");<br />
     la-&gt;resize(,19);

     la-&gt;installEventFilter(this);<br />
 }<br />
 void PaintTest::paintEvent(QPaintEvent *) {<br />
     QPainter painter(this); // this 是 PaintTest 的指针<br />
     painter.setPen(Qt::gray);<br />
     painter.setBrush(Qt::green);<br />
     painter.drawRect(, , , );<br />
 }</pre>
</div>
<p>main.cpp</p>
<div>
<pre class="prettyprint linenums"> #include &lt;QApplication&gt;

 #include "PaintTest.h"

 int main(int argc,char* argv[])<br />
 {<br />
      QApplication a(argc, argv);

     PaintTest pt;<br />
     pt.show();

      return a.exec();<br />
 }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1037399/201810/1037399-20181026150742991-1150158616.png" /></p>
<p>2.遇到的问题</p>
<p>如果行绘制的图形是在Qwidget的子的组件上应该怎么绘制在哪里绘制？</p>
<p>一般想到的是直接在paintEvent()更改</p>
<div>
<pre class="prettyprint linenums"> void PaintTest::paintEvent(QPaintEvent *) {<br />
    // QPainter painter(this); // this 是 PaintTest 的指针<br />
     QPainter painter(this-&gt;la);<br />
     painter.setPen(Qt::gray);<br />
     painter.setBrush(Qt::green);<br />
     painter.drawRect(, , , );<br />
 }</pre>
</div>
<p>运行程序，结果并没有在 Label 上绘制出矩形，而且还输出了下面的错误：</p>
<div>
<pre class="prettyprint linenums">QPainter::begin: Paint device returned engine == , type:<br />
QPainter::setPen: Painter not active<br />
QPainter::setBrush: Painter not active<br />
QPainter::drawRects: Painter not active<br />
QPainter::begin: Paint device returned engine == , type: </pre>
</div>
<p>上面1（2）提到了想要在哪个 widget 上绘图，就需要在它的 paintEvent() 函数里绘图，这里我们是想在这个Qlabel中绘图，但是paintEvent()函数是PainterTest的，所以绘制出了问题绘制不成功。</p>
<p>因此想要在QLabel中绘制图形，就必须新建一个类继承自QLAbel，然后在它的 paintEvent() 里绘图，如果单独就这个问题创建一个新的类就会有点小题大作了</p>
<p>3.解决</p>
<p>在事件过滤器&nbsp;<code>eventFilter()</code>&nbsp;中拦截 QLabel 的&nbsp;<code>QEvent::Paint</code>&nbsp;事件，用 QLabel&nbsp;创建 QPainter，就可以在 QLabel&nbsp;上绘图了</p>
<p>代码为</p>
<p>PaintTest.h</p>
<div>
<pre class="prettyprint linenums"> #ifndef PAINTTEST_H<br />
 #define PAINTTEST_H

 #include &lt;QWidget&gt;<br />
 #include &lt;QLabel&gt;<br />
 #include &lt;QPainter&gt;<br />
 class PaintTest : public QWidget<br />
 {<br />
     Q_OBJECT<br />
 private:<br />
     QLabel *la;<br />
 public:<br />
     explicit PaintTest(QWidget *parent = );<br />
  //   void paintEvent(QPaintEvent *);<br />
     bool eventFilter(QObject *watched, QEvent *event) ;<br />
     void magicTime();<br />
 signals:

 public slots:

 };<br />
 #endif // PAINTTEST_H</pre>
</div>
<p>PaintTest.cpp</p>
<div>
<pre class="prettyprint linenums"> #include "PaintTest.h"<br />
 #include &lt;QLabel&gt;<br />
 #include &lt;QEvent &gt;<br />
 PaintTest::PaintTest(QWidget *parent) :<br />
     QWidget(parent),la(new QLabel(this))<br />
 {<br />
     //la=new QLabel(this);

     la-&gt;setText("PaintTest Label");<br />
     la-&gt;resize(,);

     la-&gt;installEventFilter(this);<br />
 }<br />
 /*void PaintTest::paintEvent(QPaintEvent *) {<br />
     QPainter painter(this); // this 是 PaintTest 的指针<br />
     QPainter painter(this-&gt;la);<br />
     painter.setPen(Qt::gray);<br />
     painter.setBrush(Qt::green);<br />
     painter.drawRect(10, 10, 50, 50);<br />
 }*/

 bool PaintTest::eventFilter(QObject *watched, QEvent *event) {<br />
     if (watched == this-&gt;la &amp;&amp; event-&gt;type() == QEvent::Paint) {<br />
         magicTime();<br />
     }

     return QWidget::eventFilter(watched, event);<br />
 }

 void PaintTest::magicTime() {<br />
     QPainter painter(this-&gt;la );<br />
     painter.setPen(Qt::gray);<br />
     painter.setBrush(Qt::green);<br />
     painter.drawRect(, , , );<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwegrrq.html">MySQL中的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvw30o9.html">LeetCode Smallest Rectangle Enclosing Black Pixels</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdk3wq.html">Android中使用SurfaceView&plus;MediaPlayer&plus;自定义的MediaController实现自定义的视屏播放器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k102m79.html">鸟哥的linux私房菜学习记录之认识与分析登录档</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj4x68.html">推荐一些C&num;相关的网站、资源和书籍</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vlm1j8.html">【无聊放个模板系列】HDU 3068 MANACHER</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydl26mq.html">Eclipse使用Maven创建Web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxng1ej8.html">MyBatis Generator自动生成MyBatis的映射代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13gmr9.html">iOS网络开发-AFNetworking请求asp&period;net WebService</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkjz49.html">HDU 4435 charge-station （并查集）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5kp28.html">Docker建立本地Registry</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoxo0xq.html">SQL数据开发&lpar;经典&rpar; 基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnorv8.html">python已安装了DNS处理模块，执行时却报错ImportError</a>
		</li>
						<li><a href="https://www.batexi.com/a/950lyxv8.html">vue表单详解&mdash;&mdash;小白速会</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zonrlvq.html">Linux：进程通信之消息队列Message实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7wd59.html">torchvision 作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj05er9.html">arcgis raster clip and mask difference 栅格 提取 clip 和 mask 方法的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvk07y8.html">HBase详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oxymj8.html">golang开源项目qor快速搭建网站qor-example运行实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wyg0rq.html">使用PLSQL导出表</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25d7jwq.html">YYY0&period;1YYY</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gr5z6q.html">目标检测&lpar;二&rpar; SPPNet</a>
			</li>
						<li><a href="https://www.batexi.com/a/960ojmn9.html">Python基础学习---比较运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rv7no9.html">小程序wx&period;chooseImage的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllmj60q.html">Python 内编写类的各种技巧和方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25w5pvq.html">匹配URL</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwjpwy8.html">MAC IDEA mybatis 逆向工程 无结果文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2nj52q.html">JAVA 对接腾讯地图，经纬度转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwjmn78.html">iOS 跨App数据共享</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwjkvz8.html">2018上C语言程序设计（高级）作业- 第4次作业成绩及总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
